{-# LANGUAGE MultiParamTypeClasses,
             RankNTypes,
             FlexibleContexts,
             ImpredicativeTypes,
             TypeOperators
 #-}

module AOP.Semantics.Membranes.MonadMembrane (MonadMembrane(..)) where

import AOP.Internal.Typeable1Monad
import AOP.Internal.Joinpoint
import AOP.Semantics.Membranes.MembraneGraph
import Control.Monad.Views

-- | A membrane-aware monad that tracks the current membrane graph
class (MonadTrans t1, MonadTrans t2, Monad m, Monad (t1 (t2 m))) => MonadMembrane t1 t2 m where
      currentMembrane :: (t1 (t2 m)) MembraneId
      getGraph        :: (t1 (t2 m)) MembraneGraph
      newMembrane     :: Monad n =>
                          (forall t a b. Jp (t1 (t2 m)) a b -> Maybe (Jp (t1 (t2 m)) a b)) ->  
                          (forall t a b. Jp (t1 (t2 m)) a b -> Maybe (Jp (t1 (t2 m)) a b)) ->
                          t ->
                          n :><: (t1 (t2 m)) ->                         
                          (t1 (t2 m)) (Membrane m n t)
      advise          :: (Monad n1, Monad n2) => Membrane m n1 tag1 -> Membrane m n2 tag2 -> (t1 (t2 m)) ()
      advises         :: MembraneId -> MembraneId -> (t1 (t2 m)) Bool
      moveTo          :: Monad n => Membrane m n t -> (t1 (t2 m)) a -> (t1 (t2 m)) a
      lambda_moveTo   :: (a -> (t1 (t2 m)) b) -> MembraneId -> a -> (t1 (t2 m)) b
