> {-# LANGUAGE NoMonomorphismRestriction #-}
> {-# LANGUAGE UndecidableInstances #-}
> {-# LANGUAGE TypeOperators #-}

> module Zipper where

> import Control.Monad.Identity
> import Control.Monad.Trans
> import Control.Monad.State.Lazy
> import Control.Monad.Zipper

> data Stack  =  Trans :< Stack | Bottom Mona
> data Trans  =  T1 | Tn
> data Mona  =  I

> data Zipper   =  Zipper Path Trans Stack
>
> data Path     =  Path :>> Trans | Top 

> (>:) = Zipper

> zipper :: Stack -> Zipper
> zipper (t :< s)  = (Top >: t) s

> up, down:: Zipper -> Zipper
> up    (Zipper (p :>> t1) t2 s)   = (p >: t1) (t2 :< s)
> down  (Zipper p t1 (t2 :< s))    = (p :>> t1 >: t2) s

> zipper'  ::  t m a -> (IdentityT :> t) m a
> zipper'  =   Z . IdentityT

> step2to3 :: (t1 :> t2) (t3 m) a -> (t1 :> t2 :> t3) m a
> step2to3 = Z

> step3to4 :: (t1 :> t2 :> t3) (t4 m) a -> (t1 :> t2 :> t3 :> t4) m a
> step3to4 = Z

> rightL  :: t1 (t2 m) a -> (t1 :> t2) m a
> rightL  = Z

> leftL   :: (t1 :> t2) m a -> t1 (t2 m) a
> leftL   = runZ
